//============================亚博智能===========================
//  智能小车按键启动和蜂鸣器报警
//===============================================================
//#include <Servo.h> 
int Left_motor_back=9;       //左电机后退(IN1)
int Left_motor_go=5;         //左电机前进(IN2)

int Right_motor_go=6;        // 右电机前进(IN3)
int Right_motor_back=10;    // 右电机后退(IN4)

int Right_motor_en=8;      // 右电机前进(EN2)
int Left_motor_en=7;      // 右电机后退(EN1)

int key=4;                //定义按键 数字4 接口
int beep=3;               //定义蜂鸣器 数字3 接口


void setup()
{
  //初始化电机驱动IO为输出方式
  pinMode(Left_motor_go,OUTPUT); // PIN 5 (PWM)
  pinMode(Left_motor_back,OUTPUT); // PIN 9 (PWM)
  pinMode(Right_motor_go,OUTPUT);// PIN 6 (PWM) 
  pinMode(Right_motor_back,OUTPUT);// PIN 10 (PWM)
  
  pinMode(key,INPUT);//定义按键接口为输入接口
  pinMode(beep,OUTPUT); //定义按键接口为输出接口

  digitalWrite(key,HIGH);//初始化 按键 高电平 
  digitalWrite(beep,HIGH);//初始化  蜂鸣器 高电平
}

void run(int time)     // 前进
{
  digitalWrite(Right_motor_go,HIGH);  // 右电机前进
  digitalWrite(Right_motor_back,LOW);     
  analogWrite(Right_motor_go,200);//PWM比例0~255调速，左右轮差异略增减
  analogWrite(Right_motor_back,0);
  digitalWrite(Left_motor_go,HIGH);  // 左电机前进
  digitalWrite(Left_motor_back,LOW);
  analogWrite(Left_motor_go,200);//PWM比例0~255调速，左右轮差异略增减
  analogWrite(Left_motor_back,0);
  delay(time * 100);   //执行时间，可以调整  
}

void brake(int time)         //刹车，停车
{
  digitalWrite(Right_motor_go,LOW);
  digitalWrite(Right_motor_back,LOW);
  digitalWrite(Left_motor_go,LOW);
  digitalWrite(Left_motor_back,LOW);
  delay(time * 100);//执行时间，可以调整  
}

void left(int time)         //左转(左轮不动，右轮前进)
{
  digitalWrite(Right_motor_go,HIGH);	// 右电机前进
  digitalWrite(Right_motor_back,LOW);
  analogWrite(Right_motor_go,200); 
  analogWrite(Right_motor_back,0);//PWM比例0~255调速
  digitalWrite(Left_motor_go,LOW);   //左轮后退
  digitalWrite(Left_motor_back,LOW);
  analogWrite(Left_motor_go,0); 
  analogWrite(Left_motor_back,0);//PWM比例0~255调速
  delay(time * 100);	//执行时间，可以调整  
}

void spin_left(int time)         //左转(左轮后退，右轮前进)
{
  digitalWrite(Right_motor_go,HIGH);	// 右电机前进
  digitalWrite(Right_motor_back,LOW);
  analogWrite(Right_motor_go,200); 
  analogWrite(Right_motor_back,0);//PWM比例0~255调速
  digitalWrite(Left_motor_go,LOW);   //左轮后退
  digitalWrite(Left_motor_back,HIGH);
  analogWrite(Left_motor_go,0); 
  analogWrite(Left_motor_back,200);//PWM比例0~255调速
  delay(time * 100);	//执行时间，可以调整  
}

void right(int time)        //右转(右轮不动，左轮前进)
{
  digitalWrite(Right_motor_go,LOW);   //右电机后退
  digitalWrite(Right_motor_back,LOW);
  analogWrite(Right_motor_go,0); 
  analogWrite(Right_motor_back,0);//PWM比例0~255调速
  digitalWrite(Left_motor_go,HIGH);//左电机前进
  digitalWrite(Left_motor_back,LOW);
  analogWrite(Left_motor_go,200); 
  analogWrite(Left_motor_back,0);//PWM比例0~255调速
  delay(time * 100);	//执行时间，可以调整  
}

void spin_right(int time)        //右转(右轮后退，左轮前进)
{
  digitalWrite(Right_motor_go,LOW);   //右电机后退
  digitalWrite(Right_motor_back,HIGH);
  analogWrite(Right_motor_go,0); 
  analogWrite(Right_motor_back,200);//PWM比例0~255调速
  digitalWrite(Left_motor_go,HIGH);//左电机前进
  digitalWrite(Left_motor_back,LOW);
  analogWrite(Left_motor_go,200); 
  analogWrite(Left_motor_back,0);//PWM比例0~255调速
  delay(time * 100);	//执行时间，可以调整    
}

void back(int time)          //后退
{
  digitalWrite(Right_motor_go,LOW);  //右轮后退
  digitalWrite(Right_motor_back,HIGH);
  analogWrite(Right_motor_go,0);
  analogWrite(Right_motor_back,150);//PWM比例0~255调速
  digitalWrite(Left_motor_go,LOW);  //左轮后退
  digitalWrite(Left_motor_back,HIGH);
  analogWrite(Left_motor_go,0);
  analogWrite(Left_motor_back,150);//PWM比例0~255调速
  delay(time * 100);     //执行时间，可以调整  
}

void keysacn()
{
  int val;   
  val=digitalRead(key);//读取数字4 口电平值赋给val
  while(digitalRead(key))//当按键没被按下时，一直循环  4
  {
    val=digitalRead(key);//此句可省略，可让循环跑空
  }
  while(!digitalRead(key))//当按键被按下时
  {
    delay(10);	//延时10ms
    val=digitalRead(key);//读取数字4 口电平值赋给val 0
    if(val==LOW)  //第二次判断按键是否被按下
    {
       
      digitalWrite(beep,LOW);		//蜂鸣器响
      delay(100);//100ms
      while(!digitalRead(key))	//判断按键是否被松开
        digitalWrite(beep,HIGH);		//蜂鸣器不响
    }
    else
      digitalWrite(beep,HIGH);//蜂鸣器停止
  }
}

void loop()
{
  
  delay(2000); //延时2s后启动
  keysacn();	   //调用按键扫描函数
  
  back(10); //后退1s
  brake(5); //停止0.5s
  run(10);//前进1s
  brake(5); //停止0.5s
  left(10);//向左转1s
  right(10);//向右转1s
  spin_left(20);//向左旋转2s
  spin_right(20);//向右旋转2s
  brake(5);	 //停车
}





